/* Generated by YAKINDU Statechart Tools for Arduino v0.4.0 */

#ifndef HARDWARECONNECTOR_H
#define HARDWARECONNECTOR_H


class HardwareConnector {
public:
	inline virtual ~HardwareConnector();

	/*
	 * Initialize the hardware.
	 */
	virtual void init() = 0;

	/*
	 * Raise state machine events before processing them in the state machine's runCycle().
	 */
	virtual void raiseEvents() = 0;

	/*
	 * Update the hardware depending on the state machine's state.
	 */
	virtual void syncState() = 0;

	/*
	 * Optimize power consumption by turning off hardware modules that are not needed.
	 * Return one of the following sleep states:
	 * SLEEP_MODE_IDLE, SLEEP_MODE_ADC, SLEEP_MODE_PWR_DOWN, SLEEP_MODE_PWR_SAVE,
	 * SLEEP_MODE_STANDBY, SLEEP_MODE_EXT_STANDBY
	 * The returned sleep mode is just a recommendation, the actual timer implementation
	 * may not support the given sleep mode.
	 */
	virtual uint8_t prepareSleepMode() = 0;
};

HardwareConnector::~HardwareConnector() {
}

#endif /* HARDWARECONNECTOR_H */
