/* Generated by YAKINDU Statechart Tools for Arduino v0.4.0 */

#include "MEGA2560multitasking.h"
#include <string.h>

/*! \file Implementation of the state machine 'MEGA2560multitasking'
*/

MEGA2560multitasking::MEGA2560multitasking()
{
	
	
	stateConfVectorPosition = 0;
	
	timer = null;
}

MEGA2560multitasking::~MEGA2560multitasking()
{
}


void MEGA2560multitasking::init()
{
	for (int i = 0; i < maxOrthogonalStates; ++i)
		stateConfVector[i] = MEGA2560multitasking_last_state;
	
	stateConfVectorPosition = 0;

	clearInEvents();
	clearOutEvents();
	
	/* Default init sequence for statechart MEGA2560multitasking */
	iface.I1 = 0;
	iface.I18 = 0;
	iface.O1 = false;
	iface.O2 = false;
	iface.O3 = false;
	iface.O6 = false;
	iface.O12 = 0;
	iface.AO1 = 0;
	iface.AO2 = 0;
	iface.AI1 = 0;
	iface.AI2 = 0;
}

void MEGA2560multitasking::enter()
{
	/* Default enter sequence for statechart MEGA2560multitasking */
	enseq_main_region_default();
}

void MEGA2560multitasking::exit()
{
	/* Default exit sequence for statechart MEGA2560multitasking */
	exseq_main_region();
}

sc_boolean MEGA2560multitasking::isActive()
{
	return stateConfVector[0] != MEGA2560multitasking_last_state||stateConfVector[1] != MEGA2560multitasking_last_state||stateConfVector[2] != MEGA2560multitasking_last_state;
}

/* 
 * Always returns 'false' since this state machine can never become final.
 */
sc_boolean MEGA2560multitasking::isFinal()
{
   return false;}

void MEGA2560multitasking::runCycle()
{
	
	clearOutEvents();
	
	for (stateConfVectorPosition = 0;
		stateConfVectorPosition < maxOrthogonalStates;
		stateConfVectorPosition++)
		{
			
		switch (stateConfVector[stateConfVectorPosition])
		{
		case main_region_State10 :
		{
			react_main_region_State10();
			break;
		}
		case main_region_State11_Machine1_State20 :
		{
			react_main_region_State11_Machine1_State20();
			break;
		}
		case main_region_State11_Machine1_State21 :
		{
			react_main_region_State11_Machine1_State21();
			break;
		}
		case main_region_State11_Machine2_State30 :
		{
			react_main_region_State11_Machine2_State30();
			break;
		}
		case main_region_State11_Machine2_State31 :
		{
			react_main_region_State11_Machine2_State31();
			break;
		}
		case main_region_State11_Machine3_State40 :
		{
			react_main_region_State11_Machine3_State40();
			break;
		}
		case main_region_State11_Machine3_State41 :
		{
			react_main_region_State11_Machine3_State41();
			break;
		}
		default:
			break;
		}
	}
	
	clearInEvents();
}

void MEGA2560multitasking::clearInEvents()
{
	iface.I2_raised = false;
	iface.I11_raised = false;
	timeEvents[0] = false; 
	timeEvents[1] = false; 
	timeEvents[2] = false; 
	timeEvents[3] = false; 
}

void MEGA2560multitasking::clearOutEvents()
{
}


void MEGA2560multitasking::setTimer(TimerInterface* timer)
{
	this->timer = timer;
}

TimerInterface* MEGA2560multitasking::getTimer()
{
	return timer;
}

void MEGA2560multitasking::raiseTimeEvent(sc_eventid evid)
{
	if ((evid >= (sc_eventid)timeEvents) && (evid < (sc_eventid)(&timeEvents[timeEventsCount])))
	{
		*(sc_boolean*)evid = true;
	}				
}

sc_boolean MEGA2560multitasking::isStateActive(MEGA2560multitaskingStates state)
{
	switch (state)
	{
		case main_region_State10 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State10
			);
		case main_region_State11 : 
			return (sc_boolean) (stateConfVector[0] >= main_region_State11
				&& stateConfVector[0] <= main_region_State11_Machine3_State41);
		case main_region_State11_Machine1_State20 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State11_Machine1_State20
			);
		case main_region_State11_Machine1_State21 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State11_Machine1_State21
			);
		case main_region_State11_Machine2_State30 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_Machine2_State30
			);
		case main_region_State11_Machine2_State31 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_Machine2_State31
			);
		case main_region_State11_Machine3_State40 : 
			return (sc_boolean) (stateConfVector[2] == main_region_State11_Machine3_State40
			);
		case main_region_State11_Machine3_State41 : 
			return (sc_boolean) (stateConfVector[2] == main_region_State11_Machine3_State41
			);
		default: return false;
	}
}

MEGA2560multitasking::DefaultSCI* MEGA2560multitasking::getDefaultSCI()
{
	return &iface;
}

void MEGA2560multitasking::DefaultSCI::raise_i2()
{
	I2_raised = true;
}

void MEGA2560multitasking::raise_i2()
{
	iface.raise_i2();
}

void MEGA2560multitasking::DefaultSCI::raise_i11()
{
	I11_raised = true;
}

void MEGA2560multitasking::raise_i11()
{
	iface.raise_i11();
}


sc_integer MEGA2560multitasking::DefaultSCI::get_i1()
{
	return I1;
}

sc_integer MEGA2560multitasking::get_i1()
{
	return iface.I1;
}

void MEGA2560multitasking::DefaultSCI::set_i1(sc_integer value)
{
	I1 = value;
}

void MEGA2560multitasking::set_i1(sc_integer value)
{
	iface.I1 = value;
}

sc_integer MEGA2560multitasking::DefaultSCI::get_i18()
{
	return I18;
}

sc_integer MEGA2560multitasking::get_i18()
{
	return iface.I18;
}

void MEGA2560multitasking::DefaultSCI::set_i18(sc_integer value)
{
	I18 = value;
}

void MEGA2560multitasking::set_i18(sc_integer value)
{
	iface.I18 = value;
}

sc_boolean MEGA2560multitasking::DefaultSCI::get_o1()
{
	return O1;
}

sc_boolean MEGA2560multitasking::get_o1()
{
	return iface.O1;
}

void MEGA2560multitasking::DefaultSCI::set_o1(sc_boolean value)
{
	O1 = value;
}

void MEGA2560multitasking::set_o1(sc_boolean value)
{
	iface.O1 = value;
}

sc_boolean MEGA2560multitasking::DefaultSCI::get_o2()
{
	return O2;
}

sc_boolean MEGA2560multitasking::get_o2()
{
	return iface.O2;
}

void MEGA2560multitasking::DefaultSCI::set_o2(sc_boolean value)
{
	O2 = value;
}

void MEGA2560multitasking::set_o2(sc_boolean value)
{
	iface.O2 = value;
}

sc_boolean MEGA2560multitasking::DefaultSCI::get_o3()
{
	return O3;
}

sc_boolean MEGA2560multitasking::get_o3()
{
	return iface.O3;
}

void MEGA2560multitasking::DefaultSCI::set_o3(sc_boolean value)
{
	O3 = value;
}

void MEGA2560multitasking::set_o3(sc_boolean value)
{
	iface.O3 = value;
}

sc_boolean MEGA2560multitasking::DefaultSCI::get_o6()
{
	return O6;
}

sc_boolean MEGA2560multitasking::get_o6()
{
	return iface.O6;
}

void MEGA2560multitasking::DefaultSCI::set_o6(sc_boolean value)
{
	O6 = value;
}

void MEGA2560multitasking::set_o6(sc_boolean value)
{
	iface.O6 = value;
}

sc_integer MEGA2560multitasking::DefaultSCI::get_o12()
{
	return O12;
}

sc_integer MEGA2560multitasking::get_o12()
{
	return iface.O12;
}

void MEGA2560multitasking::DefaultSCI::set_o12(sc_integer value)
{
	O12 = value;
}

void MEGA2560multitasking::set_o12(sc_integer value)
{
	iface.O12 = value;
}

sc_integer MEGA2560multitasking::DefaultSCI::get_aO1()
{
	return AO1;
}

sc_integer MEGA2560multitasking::get_aO1()
{
	return iface.AO1;
}

void MEGA2560multitasking::DefaultSCI::set_aO1(sc_integer value)
{
	AO1 = value;
}

void MEGA2560multitasking::set_aO1(sc_integer value)
{
	iface.AO1 = value;
}

sc_integer MEGA2560multitasking::DefaultSCI::get_aO2()
{
	return AO2;
}

sc_integer MEGA2560multitasking::get_aO2()
{
	return iface.AO2;
}

void MEGA2560multitasking::DefaultSCI::set_aO2(sc_integer value)
{
	AO2 = value;
}

void MEGA2560multitasking::set_aO2(sc_integer value)
{
	iface.AO2 = value;
}

sc_integer MEGA2560multitasking::DefaultSCI::get_aI1()
{
	return AI1;
}

sc_integer MEGA2560multitasking::get_aI1()
{
	return iface.AI1;
}

void MEGA2560multitasking::DefaultSCI::set_aI1(sc_integer value)
{
	AI1 = value;
}

void MEGA2560multitasking::set_aI1(sc_integer value)
{
	iface.AI1 = value;
}

sc_integer MEGA2560multitasking::DefaultSCI::get_aI2()
{
	return AI2;
}

sc_integer MEGA2560multitasking::get_aI2()
{
	return iface.AI2;
}

void MEGA2560multitasking::DefaultSCI::set_aI2(sc_integer value)
{
	AI2 = value;
}

void MEGA2560multitasking::set_aI2(sc_integer value)
{
	iface.AI2 = value;
}


// implementations of all internal functions

sc_boolean MEGA2560multitasking::check_main_region_State10_tr0_tr0()
{
	return iface.I1 == 1;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr1_lr1()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr2_lr2()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr3_lr3()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr4_lr4()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr5_lr5()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State10_lr6_lr6()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_tr0_tr0()
{
	return iface.I1 == 0;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_lr1_lr1()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_lr2_lr2()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine1_State20_tr0_tr0()
{
	return timeEvents[0];
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine1_State20_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine1_State21_tr0_tr0()
{
	return timeEvents[1];
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine1_State21_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine2_State30_tr0_tr0()
{
	return timeEvents[2];
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine2_State30_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine2_State31_tr0_tr0()
{
	return timeEvents[3];
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine2_State31_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State40_tr0_tr0()
{
	return iface.I2_raised;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State40_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State40_lr1_lr1()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State41_tr0_tr0()
{
	return iface.I11_raised;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State41_lr0_lr0()
{
	return true;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State41_lr1_lr1()
{
	return iface.I18 == 1;
}

sc_boolean MEGA2560multitasking::check_main_region_State11_Machine3_State41_lr2_lr2()
{
	return iface.I18 == 0;
}

void MEGA2560multitasking::effect_main_region_State10_tr0()
{
	exseq_main_region_State10();
	enseq_main_region_State11_default();
}

void MEGA2560multitasking::effect_main_region_State10_lr0_lr0()
{
	iface.O1 = false;
}

void MEGA2560multitasking::effect_main_region_State10_lr1_lr1()
{
	iface.O2 = false;
}

void MEGA2560multitasking::effect_main_region_State10_lr2_lr2()
{
	iface.O3 = false;
}

void MEGA2560multitasking::effect_main_region_State10_lr3_lr3()
{
	iface.O6 = false;
}

void MEGA2560multitasking::effect_main_region_State10_lr4_lr4()
{
	iface.O12 = 0;
}

void MEGA2560multitasking::effect_main_region_State10_lr5_lr5()
{
	iface.AO1 = 0;
}

void MEGA2560multitasking::effect_main_region_State10_lr6_lr6()
{
	iface.AO2 = 0;
}

void MEGA2560multitasking::effect_main_region_State11_tr0()
{
	exseq_main_region_State11();
	enseq_main_region_State10_default();
}

void MEGA2560multitasking::effect_main_region_State11_lr0_lr0()
{
	iface.O3 = true;
}

void MEGA2560multitasking::effect_main_region_State11_lr1_lr1()
{
	iface.AO1 = iface.AI1;
}

void MEGA2560multitasking::effect_main_region_State11_lr2_lr2()
{
	iface.AO2 = iface.AI2;
}

void MEGA2560multitasking::effect_main_region_State11_Machine1_State20_tr0()
{
	exseq_main_region_State11_Machine1_State20();
	enseq_main_region_State11_Machine1_State21_default();
}

void MEGA2560multitasking::effect_main_region_State11_Machine1_State20_lr0_lr0()
{
	iface.O1 = false;
}

void MEGA2560multitasking::effect_main_region_State11_Machine1_State21_tr0()
{
	exseq_main_region_State11_Machine1_State21();
	enseq_main_region_State11_Machine1_State20_default();
}

void MEGA2560multitasking::effect_main_region_State11_Machine1_State21_lr0_lr0()
{
	iface.O1 = true;
}

void MEGA2560multitasking::effect_main_region_State11_Machine2_State30_tr0()
{
	exseq_main_region_State11_Machine2_State30();
	enseq_main_region_State11_Machine2_State31_default();
}

void MEGA2560multitasking::effect_main_region_State11_Machine2_State30_lr0_lr0()
{
	iface.O2 = false;
}

void MEGA2560multitasking::effect_main_region_State11_Machine2_State31_tr0()
{
	exseq_main_region_State11_Machine2_State31();
	enseq_main_region_State11_Machine2_State30_default();
}

void MEGA2560multitasking::effect_main_region_State11_Machine2_State31_lr0_lr0()
{
	iface.O2 = true;
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State40_tr0()
{
	exseq_main_region_State11_Machine3_State40();
	enseq_main_region_State11_Machine3_State41_default();
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State40_lr0_lr0()
{
	iface.O6 = false;
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State40_lr1_lr1()
{
	iface.O12 = 0;
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State41_tr0()
{
	exseq_main_region_State11_Machine3_State41();
	enseq_main_region_State11_Machine3_State40_default();
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State41_lr0_lr0()
{
	iface.O6 = true;
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State41_lr1_lr1()
{
	iface.O12 = 1;
}

void MEGA2560multitasking::effect_main_region_State11_Machine3_State41_lr2_lr2()
{
	iface.O12 = 0;
}

/* Entry action for state 'State20'. */
void MEGA2560multitasking::enact_main_region_State11_Machine1_State20()
{
	/* Entry action for state 'State20'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[0]), 300, false);
}

/* Entry action for state 'State21'. */
void MEGA2560multitasking::enact_main_region_State11_Machine1_State21()
{
	/* Entry action for state 'State21'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[1]), 500, false);
}

/* Entry action for state 'State30'. */
void MEGA2560multitasking::enact_main_region_State11_Machine2_State30()
{
	/* Entry action for state 'State30'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[2]), 700, false);
}

/* Entry action for state 'State31'. */
void MEGA2560multitasking::enact_main_region_State11_Machine2_State31()
{
	/* Entry action for state 'State31'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[3]), 700, false);
}

/* Exit action for state 'State20'. */
void MEGA2560multitasking::exact_main_region_State11_Machine1_State20()
{
	/* Exit action for state 'State20'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[0]));
}

/* Exit action for state 'State21'. */
void MEGA2560multitasking::exact_main_region_State11_Machine1_State21()
{
	/* Exit action for state 'State21'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[1]));
}

/* Exit action for state 'State30'. */
void MEGA2560multitasking::exact_main_region_State11_Machine2_State30()
{
	/* Exit action for state 'State30'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[2]));
}

/* Exit action for state 'State31'. */
void MEGA2560multitasking::exact_main_region_State11_Machine2_State31()
{
	/* Exit action for state 'State31'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[3]));
}

/* 'default' enter sequence for state State10 */
void MEGA2560multitasking::enseq_main_region_State10_default()
{
	/* 'default' enter sequence for state State10 */
	stateConfVector[0] = main_region_State10;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State11 */
void MEGA2560multitasking::enseq_main_region_State11_default()
{
	/* 'default' enter sequence for state State11 */
	enseq_main_region_State11_Machine1_default();
	enseq_main_region_State11_Machine2_default();
	enseq_main_region_State11_Machine3_default();
}

/* 'default' enter sequence for state State20 */
void MEGA2560multitasking::enseq_main_region_State11_Machine1_State20_default()
{
	/* 'default' enter sequence for state State20 */
	enact_main_region_State11_Machine1_State20();
	stateConfVector[0] = main_region_State11_Machine1_State20;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State21 */
void MEGA2560multitasking::enseq_main_region_State11_Machine1_State21_default()
{
	/* 'default' enter sequence for state State21 */
	enact_main_region_State11_Machine1_State21();
	stateConfVector[0] = main_region_State11_Machine1_State21;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State30 */
void MEGA2560multitasking::enseq_main_region_State11_Machine2_State30_default()
{
	/* 'default' enter sequence for state State30 */
	enact_main_region_State11_Machine2_State30();
	stateConfVector[1] = main_region_State11_Machine2_State30;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State31 */
void MEGA2560multitasking::enseq_main_region_State11_Machine2_State31_default()
{
	/* 'default' enter sequence for state State31 */
	enact_main_region_State11_Machine2_State31();
	stateConfVector[1] = main_region_State11_Machine2_State31;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State40 */
void MEGA2560multitasking::enseq_main_region_State11_Machine3_State40_default()
{
	/* 'default' enter sequence for state State40 */
	stateConfVector[2] = main_region_State11_Machine3_State40;
	stateConfVectorPosition = 2;
}

/* 'default' enter sequence for state State41 */
void MEGA2560multitasking::enseq_main_region_State11_Machine3_State41_default()
{
	/* 'default' enter sequence for state State41 */
	stateConfVector[2] = main_region_State11_Machine3_State41;
	stateConfVectorPosition = 2;
}

/* 'default' enter sequence for region main region */
void MEGA2560multitasking::enseq_main_region_default()
{
	/* 'default' enter sequence for region main region */
	react_main_region__entry_Default();
}

/* 'default' enter sequence for region Machine1 */
void MEGA2560multitasking::enseq_main_region_State11_Machine1_default()
{
	/* 'default' enter sequence for region Machine1 */
	react_main_region_State11_Machine1__entry_Default();
}

/* 'default' enter sequence for region Machine2 */
void MEGA2560multitasking::enseq_main_region_State11_Machine2_default()
{
	/* 'default' enter sequence for region Machine2 */
	react_main_region_State11_Machine2__entry_Default();
}

/* 'default' enter sequence for region Machine3 */
void MEGA2560multitasking::enseq_main_region_State11_Machine3_default()
{
	/* 'default' enter sequence for region Machine3 */
	react_main_region_State11_Machine3__entry_Default();
}

/* Default exit sequence for state State10 */
void MEGA2560multitasking::exseq_main_region_State10()
{
	/* Default exit sequence for state State10 */
	stateConfVector[0] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 0;
}

/* Default exit sequence for state State11 */
void MEGA2560multitasking::exseq_main_region_State11()
{
	/* Default exit sequence for state State11 */
	exseq_main_region_State11_Machine1();
	exseq_main_region_State11_Machine2();
	exseq_main_region_State11_Machine3();
}

/* Default exit sequence for state State20 */
void MEGA2560multitasking::exseq_main_region_State11_Machine1_State20()
{
	/* Default exit sequence for state State20 */
	stateConfVector[0] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 0;
	exact_main_region_State11_Machine1_State20();
}

/* Default exit sequence for state State21 */
void MEGA2560multitasking::exseq_main_region_State11_Machine1_State21()
{
	/* Default exit sequence for state State21 */
	stateConfVector[0] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 0;
	exact_main_region_State11_Machine1_State21();
}

/* Default exit sequence for state State30 */
void MEGA2560multitasking::exseq_main_region_State11_Machine2_State30()
{
	/* Default exit sequence for state State30 */
	stateConfVector[1] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 1;
	exact_main_region_State11_Machine2_State30();
}

/* Default exit sequence for state State31 */
void MEGA2560multitasking::exseq_main_region_State11_Machine2_State31()
{
	/* Default exit sequence for state State31 */
	stateConfVector[1] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 1;
	exact_main_region_State11_Machine2_State31();
}

/* Default exit sequence for state State40 */
void MEGA2560multitasking::exseq_main_region_State11_Machine3_State40()
{
	/* Default exit sequence for state State40 */
	stateConfVector[2] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 2;
}

/* Default exit sequence for state State41 */
void MEGA2560multitasking::exseq_main_region_State11_Machine3_State41()
{
	/* Default exit sequence for state State41 */
	stateConfVector[2] = MEGA2560multitasking_last_state;
	stateConfVectorPosition = 2;
}

/* Default exit sequence for region main region */
void MEGA2560multitasking::exseq_main_region()
{
	/* Default exit sequence for region main region */
	/* Handle exit of all possible states (of MEGA2560multitasking.main_region) at position 0... */
	switch(stateConfVector[ 0 ])
	{
		case main_region_State10 :
		{
			exseq_main_region_State10();
			break;
		}
		case main_region_State11_Machine1_State20 :
		{
			exseq_main_region_State11_Machine1_State20();
			break;
		}
		case main_region_State11_Machine1_State21 :
		{
			exseq_main_region_State11_Machine1_State21();
			break;
		}
		default: break;
	}
	/* Handle exit of all possible states (of MEGA2560multitasking.main_region) at position 1... */
	switch(stateConfVector[ 1 ])
	{
		case main_region_State11_Machine2_State30 :
		{
			exseq_main_region_State11_Machine2_State30();
			break;
		}
		case main_region_State11_Machine2_State31 :
		{
			exseq_main_region_State11_Machine2_State31();
			break;
		}
		default: break;
	}
	/* Handle exit of all possible states (of MEGA2560multitasking.main_region) at position 2... */
	switch(stateConfVector[ 2 ])
	{
		case main_region_State11_Machine3_State40 :
		{
			exseq_main_region_State11_Machine3_State40();
			break;
		}
		case main_region_State11_Machine3_State41 :
		{
			exseq_main_region_State11_Machine3_State41();
			break;
		}
		default: break;
	}
}

/* Default exit sequence for region Machine1 */
void MEGA2560multitasking::exseq_main_region_State11_Machine1()
{
	/* Default exit sequence for region Machine1 */
	/* Handle exit of all possible states (of MEGA2560multitasking.main_region.State11.Machine1) at position 0... */
	switch(stateConfVector[ 0 ])
	{
		case main_region_State11_Machine1_State20 :
		{
			exseq_main_region_State11_Machine1_State20();
			break;
		}
		case main_region_State11_Machine1_State21 :
		{
			exseq_main_region_State11_Machine1_State21();
			break;
		}
		default: break;
	}
}

/* Default exit sequence for region Machine2 */
void MEGA2560multitasking::exseq_main_region_State11_Machine2()
{
	/* Default exit sequence for region Machine2 */
	/* Handle exit of all possible states (of MEGA2560multitasking.main_region.State11.Machine2) at position 1... */
	switch(stateConfVector[ 1 ])
	{
		case main_region_State11_Machine2_State30 :
		{
			exseq_main_region_State11_Machine2_State30();
			break;
		}
		case main_region_State11_Machine2_State31 :
		{
			exseq_main_region_State11_Machine2_State31();
			break;
		}
		default: break;
	}
}

/* Default exit sequence for region Machine3 */
void MEGA2560multitasking::exseq_main_region_State11_Machine3()
{
	/* Default exit sequence for region Machine3 */
	/* Handle exit of all possible states (of MEGA2560multitasking.main_region.State11.Machine3) at position 2... */
	switch(stateConfVector[ 2 ])
	{
		case main_region_State11_Machine3_State40 :
		{
			exseq_main_region_State11_Machine3_State40();
			break;
		}
		case main_region_State11_Machine3_State41 :
		{
			exseq_main_region_State11_Machine3_State41();
			break;
		}
		default: break;
	}
}

/* The reactions of state State10. */
void MEGA2560multitasking::react_main_region_State10()
{
	/* The reactions of state State10. */
	if (check_main_region_State10_tr0_tr0())
	{ 
		effect_main_region_State10_tr0();
	}  else
	{
		effect_main_region_State10_lr0_lr0();
		effect_main_region_State10_lr1_lr1();
		effect_main_region_State10_lr2_lr2();
		effect_main_region_State10_lr3_lr3();
		effect_main_region_State10_lr4_lr4();
		effect_main_region_State10_lr5_lr5();
		effect_main_region_State10_lr6_lr6();
	}
}

/* The reactions of state State20. */
void MEGA2560multitasking::react_main_region_State11_Machine1_State20()
{
	/* The reactions of state State20. */
	if (check_main_region_State11_tr0_tr0())
	{ 
		effect_main_region_State11_tr0();
	}  else
	{
		effect_main_region_State11_lr0_lr0();
		effect_main_region_State11_lr1_lr1();
		effect_main_region_State11_lr2_lr2();
		if (check_main_region_State11_Machine1_State20_tr0_tr0())
		{ 
			effect_main_region_State11_Machine1_State20_tr0();
		}  else
		{
			effect_main_region_State11_Machine1_State20_lr0_lr0();
		}
	}
}

/* The reactions of state State21. */
void MEGA2560multitasking::react_main_region_State11_Machine1_State21()
{
	/* The reactions of state State21. */
	if (check_main_region_State11_tr0_tr0())
	{ 
		effect_main_region_State11_tr0();
	}  else
	{
		effect_main_region_State11_lr0_lr0();
		effect_main_region_State11_lr1_lr1();
		effect_main_region_State11_lr2_lr2();
		if (check_main_region_State11_Machine1_State21_tr0_tr0())
		{ 
			effect_main_region_State11_Machine1_State21_tr0();
		}  else
		{
			effect_main_region_State11_Machine1_State21_lr0_lr0();
		}
	}
}

/* The reactions of state State30. */
void MEGA2560multitasking::react_main_region_State11_Machine2_State30()
{
	/* The reactions of state State30. */
	if (check_main_region_State11_Machine2_State30_tr0_tr0())
	{ 
		effect_main_region_State11_Machine2_State30_tr0();
	}  else
	{
		effect_main_region_State11_Machine2_State30_lr0_lr0();
	}
}

/* The reactions of state State31. */
void MEGA2560multitasking::react_main_region_State11_Machine2_State31()
{
	/* The reactions of state State31. */
	if (check_main_region_State11_Machine2_State31_tr0_tr0())
	{ 
		effect_main_region_State11_Machine2_State31_tr0();
	}  else
	{
		effect_main_region_State11_Machine2_State31_lr0_lr0();
	}
}

/* The reactions of state State40. */
void MEGA2560multitasking::react_main_region_State11_Machine3_State40()
{
	/* The reactions of state State40. */
	if (check_main_region_State11_Machine3_State40_tr0_tr0())
	{ 
		effect_main_region_State11_Machine3_State40_tr0();
	}  else
	{
		effect_main_region_State11_Machine3_State40_lr0_lr0();
		effect_main_region_State11_Machine3_State40_lr1_lr1();
	}
}

/* The reactions of state State41. */
void MEGA2560multitasking::react_main_region_State11_Machine3_State41()
{
	/* The reactions of state State41. */
	if (check_main_region_State11_Machine3_State41_tr0_tr0())
	{ 
		effect_main_region_State11_Machine3_State41_tr0();
	}  else
	{
		effect_main_region_State11_Machine3_State41_lr0_lr0();
		if (check_main_region_State11_Machine3_State41_lr1_lr1())
		{ 
			effect_main_region_State11_Machine3_State41_lr1_lr1();
		} 
		if (check_main_region_State11_Machine3_State41_lr2_lr2())
		{ 
			effect_main_region_State11_Machine3_State41_lr2_lr2();
		} 
	}
}

/* Default react sequence for initial entry  */
void MEGA2560multitasking::react_main_region__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State10_default();
}

/* Default react sequence for initial entry  */
void MEGA2560multitasking::react_main_region_State11_Machine1__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State11_Machine1_State20_default();
}

/* Default react sequence for initial entry  */
void MEGA2560multitasking::react_main_region_State11_Machine2__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State11_Machine2_State30_default();
}

/* Default react sequence for initial entry  */
void MEGA2560multitasking::react_main_region_State11_Machine3__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State11_Machine3_State40_default();
}


