/* Generated by YAKINDU Statechart Tools for Arduino v0.4.0 */

#ifndef ATMEGA_TIMER1_H
#define ATMEGA_TIMER1_H

#include <avr/sleep.h>
#include <Arduino.h>

#include "sc_types.h"
#include "TimerInterface.h"
#include "StatemachineInterface.h"
#include "TimedStatemachineInterface.h"
#include "TimeEvent.h"
#include "HardwareConnector.h"

class ATmega_Timer1: public TimerInterface {
public:
	/* period in milliseconds */
	ATmega_Timer1(StatemachineInterface* statemachine, HardwareConnector* hardware,
			unsigned char maxParallelTimeEvents, unsigned int period);
	
	inline ~ATmega_Timer1();
	
	void start();
	
	void setTimer(TimedStatemachineInterface* timedStatemachine, sc_eventid eventId, sc_integer time,
			sc_boolean isPeriodic);
	
	void unsetTimer(TimedStatemachineInterface* timedStatemachine, sc_eventid eventId);
	
	void runCycle();
	
	void cancel();

private:
	StatemachineInterface* statemachine;
	
	HardwareConnector* hardware;
	
	TimeEvent* events;
	
	unsigned int period;
	
	unsigned char maxParallelTimeEvents;
	
	void init();
	
	void raiseTimeEvents();
	
	void sleep();
};

ATmega_Timer1::~ATmega_Timer1() {
	delete events;
}

#endif /* ATMEGA_TIMER1_H */
